/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@ricochet.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2001-2004 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.venice.core;

import java.io.IOException;
import java.io.Writer;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;
import com.silverwrist.venice.except.DataException;
import com.silverwrist.venice.security.Role;

public interface AdminUserContext
{
  public int getUID();

  public String getUserName();

  public int getContactID();

  public String getDescription();

  public void setDescription(String new_descr) throws DataException;

  public int getBaseLevel();

  public void setBaseLevel(int new_level) throws DataException;

  public Role getBaseRole();

  public void setBaseRole(Role new_role) throws DataException;

  public boolean isEmailVerified();

  public void setEmailVerified(boolean flag) throws DataException;

  public boolean isLockedOut();

  public void setLockedOut(boolean flag) throws DataException;

  public ContactInfo getContactInfo() throws DataException;

  public void putContactInfo(ContactInfo ci) throws DataException;

  public void setPassword(String password, String reminder) throws DataException;

  public Locale getLocale();

  public void setLocale(Locale locale) throws DataException;

  public TimeZone getTimeZone();

  public void setTimeZone(TimeZone timezone) throws DataException;

  public Date getCreationDate();

  public Date getLastAccessDate();

  public AdminUserProperties getProperties() throws DataException;

  public void setProperties(AdminUserProperties props) throws DataException;

  public void export(Writer xml) throws IOException, DataException;

  public java.sql.Date getDateOfBirth();

  public void setDateOfBirth(java.sql.Date date) throws DataException;

} // end interface AdminUserContext
